RtsDefine(['rtsmvc', 'model/Playlist', 'model/Member', 'model/Media'], function() {

	(function(ns){
		ns.ControllerAddMediaHistory = ns.Controller.extend({
			events : {
				"change:*"               : "onModelChange",
				"session:model:ready"    : "onModelChange",
                "session:model:reload"   : "onModelChange"
			},

			setParam : function(mediaId) {

				this.mediaId = mediaId;
				var session = ns.SessionMember();
				this.setModel(session, "session");
				
			},
			onModelChange : function() {
				var me = this;
				this.getModel("session").getMember(function(logged, member) {
					if (member.isLogged()) {
						me.controllerPlaylistCollection = new ControllerPlaylistCollection();
						me.controllerPlaylistCollection.add(2, me.mediaId);
						me.controllerPlaylistCollection.getCollection().load(0,100);
					}
				}); 
			}
		});

		ns.ControllerAddMediaHistoryShared = ns.Util.makeShareable(ns.ControllerAddMediaHistory);

		var ControllerPlaylistCollection = ns.Controller.extend({
			events : {
				"collection:load" : "onCollectionLoad"
			},
			construct : {
				collection : ns.PlaylistCollection
			},
			add : function(type, mediaId) {
				this.type = type;
				this.mediaId = mediaId;
			},
			onCollectionLoad : function(){
				this.collection.each(function(index, item){
				if(item.get("idPlaylistType") == this.type) {
					var plHist = new ControllerPlaylist();
					plHist.setParams(this.mediaId);
					plHist.setModel(item);
				}
				}, this);
			}
		});

		var ControllerPlaylist = ns.Controller.extend({
			events : {
				"model:set" : "onModelSet"
			},
			construct : {
				model : ns.Playlist
			},
			setParams : function(mediaId){
				this.mediaId = mediaId;
			},
			onModelSet : function(){
				var media = new ns.Media();
				var pl = this;
				media.loadById(this.mediaId, { success : function(){
					pl.model.get("article").addItemAtFirst(this, {success : function(){}});
				}});
			}
		});
	})(rtsmvc);
});
